Index: thirdparty/SZ/sz/src/szd_double.c
===================================================================
--- thirdparty/SZ/sz/src/szd_double.c	(revision 2c47b734c78138a26f64051bee9d14ecd93594b3)
+++ thirdparty/SZ/sz/src/szd_double.c	(revision 9ee2ce3c0d78f4ec0c8dee6bba00cac6e8b2f339)
@@ -17,4 +17,5 @@
 #include "szd_double_pwr.h"
 #include "szd_double_ts.h"
+#include "utility.h"
 
 int SZ_decompress_args_double(double** newData, size_t r5, size_t r4, size_t r3, size_t r2, size_t r1, unsigned char* cmpBytes, size_t cmpSize)
@@ -30,8 +31,8 @@
 	if(cmpSize!=12+4+MetaDataByteLength && cmpSize!=12+8+MetaDataByteLength)
 	{
-		int isZlib = isZlibFormat(cmpBytes[0], cmpBytes[1]);
+		confparams_dec->losslessCompressor = is_lossless_compressed_data(cmpBytes, cmpSize);
 		if(confparams_dec->szMode!=SZ_TEMPORAL_COMPRESSION)
 		{
-			if(isZlib)
+			if(confparams_dec->losslessCompressor!=-1)
 				confparams_dec->szMode = SZ_BEST_COMPRESSION;
 			else
@@ -47,5 +48,5 @@
 			if(targetUncompressSize<MIN_ZLIB_DEC_ALLOMEM_BYTES) //Considering the minimum size
 				targetUncompressSize = MIN_ZLIB_DEC_ALLOMEM_BYTES; 			
-			tmpSize = zlib_uncompress5(cmpBytes, (unsigned long)cmpSize, &szTmpBytes, (unsigned long)targetUncompressSize+4+MetaDataByteLength+exe_params->SZ_SIZE_TYPE);			
+			tmpSize = sz_lossless_decompress(confparams_dec->losslessCompressor, cmpBytes, (unsigned long)cmpSize, &szTmpBytes, (unsigned long)targetUncompressSize+4+MetaDataByteLength+exe_params->SZ_SIZE_TYPE);			
 			//szTmpBytes = (unsigned char*)malloc(sizeof(unsigned char)*tmpSize);
 			//memcpy(szTmpBytes, tmpBytes, tmpSize);
@@ -81,20 +82,43 @@
 		}		
 	}
-	else if (dim == 1)
-		getSnapshotData_double_1D(newData,r1,tdps, errBoundMode);
-	else
-	if (dim == 2)
-		getSnapshotData_double_2D(newData,r2,r1,tdps, errBoundMode);
-	else
-	if (dim == 3)
-		getSnapshotData_double_3D(newData,r3,r2,r1,tdps, errBoundMode);
-	else
-	if (dim == 4)
-		getSnapshotData_double_4D(newData,r4,r3,r2,r1,tdps, errBoundMode);
-	else
+	else 
 	{
-		printf("Error: currently support only at most 4 dimensions!\n");
-		status = SZ_DERR;
-	}
+		if(tdps->raBytes_size > 0) //v2.0
+		{
+			if (dim == 1)
+				getSnapshotData_double_1D(newData,r1,tdps, errBoundMode);
+			else if(dim == 2)
+				decompressDataSeries_double_2D_nonblocked_with_blocked_regression(newData, r2, r1, tdps->raBytes);
+			else if(dim == 3)
+				decompressDataSeries_double_3D_nonblocked_with_blocked_regression(newData, r3, r2, r1, tdps->raBytes);
+			else if(dim == 4)
+				decompressDataSeries_double_3D_nonblocked_with_blocked_regression(newData, r4*r3, r2, r1, tdps->raBytes);
+			else
+			{
+				printf("Error: currently support only at most 4 dimensions!\n");
+				status = SZ_DERR;
+			}	
+		}
+		else //1.4.13
+		{
+			if (dim == 1)
+				getSnapshotData_double_1D(newData,r1,tdps, errBoundMode);
+			else
+			if (dim == 2)
+				getSnapshotData_double_2D(newData,r2,r1,tdps, errBoundMode);
+			else
+			if (dim == 3)
+				getSnapshotData_double_3D(newData,r3,r2,r1,tdps, errBoundMode);
+			else
+			if (dim == 4)
+				getSnapshotData_double_4D(newData,r4,r3,r2,r1,tdps, errBoundMode);			
+			else
+			{
+				printf("Error: currently support only at most 4 dimensions!\n");
+				status = SZ_DERR;
+			}			
+		}
+	}	
+
 	free_TightDataPointStorageD2(tdps);
 	if(confparams_dec->szMode!=SZ_BEST_SPEED && cmpSize!=12+MetaDataByteLength+exe_params->SZ_SIZE_TYPE)
@@ -1648,6 +1672,6 @@
 			else 
 			{
-				//decompressDataSeries_double_1D_pwr(data, dataSeriesLength, tdps);
-				decompressDataSeries_double_1D_pwrgroup(data, dataSeriesLength, tdps);
+				decompressDataSeries_double_1D_pwr_pre_log(data, dataSeriesLength, tdps);
+				//decompressDataSeries_double_1D_pwrgroup(data, dataSeriesLength, tdps);
 			}
 			return;
@@ -1672,5 +1696,6 @@
 				decompressDataSeries_double_1D(&decmpData, dataSeriesLength, tdps);
 			else 
-				decompressDataSeries_double_1D_pwr(&decmpData, dataSeriesLength, tdps);
+				//decompressDataSeries_double_1D_pwr(&decmpData, dataSeriesLength, tdps);
+				decompressDataSeries_double_1D_pwr_pre_log(&decmpData, dataSeriesLength, tdps);
 			// insert the decompressed data
 			size_t k = 0;
@@ -1712,5 +1737,6 @@
 			}
 			else 
-				decompressDataSeries_double_2D_pwr(data, r1, r2, tdps);
+				//decompressDataSeries_double_2D_pwr(data, r1, r2, tdps);
+				decompressDataSeries_double_2D_pwr_pre_log(data, r1, r2, tdps);
 			return;
 		} else {
@@ -1734,5 +1760,6 @@
 				decompressDataSeries_double_2D(&decmpData, r1, r2, tdps);
 			else 
-				decompressDataSeries_double_2D_pwr(&decmpData, r1, r2, tdps);
+				//decompressDataSeries_double_2D_pwr(&decmpData, r1, r2, tdps);
+				decompressDataSeries_double_2D_pwr_pre_log(&decmpData, r1, r2, tdps);
 			// insert the decompressed data
 			size_t k = 0;
@@ -1774,5 +1801,6 @@
 			}
 			else 
-				decompressDataSeries_double_3D_pwr(data, r1, r2, r3, tdps);
+				//decompressDataSeries_double_3D_pwr(data, r1, r2, r3, tdps);
+				decompressDataSeries_double_3D_pwr_pre_log(data, r1, r2, r3, tdps);
 			return;
 		} else {
@@ -1796,5 +1824,6 @@
 				decompressDataSeries_double_3D(&decmpData, r1, r2, r3, tdps);
 			else 
-				decompressDataSeries_double_3D_pwr(&decmpData, r1, r2, r3, tdps);			
+				//decompressDataSeries_double_3D_pwr(&decmpData, r1, r2, r3, tdps);			
+				decompressDataSeries_double_3D_pwr_pre_log(&decmpData, r1, r2, r3, tdps);			
 			// insert the decompressed data
 			size_t k = 0;
@@ -1837,5 +1866,6 @@
 			else 
 			{
-				decompressDataSeries_double_3D_pwr(data, r1*r2, r3, r4, tdps);
+				//decompressDataSeries_double_3D_pwr(data, r1*r2, r3, r4, tdps);
+				decompressDataSeries_double_3D_pwr_pre_log(data, r1*r2, r3, r4, tdps);
 				//ToDO
 				//decompressDataSeries_double_4D_pwr(data, r1, r2, r3, r4, tdps);
@@ -1859,5 +1889,6 @@
 				decompressDataSeries_double_4D(&decmpData, r1, r2, r3, r4, tdps);
 			else
-				decompressDataSeries_double_3D_pwr(&decmpData, r1*r2, r3, r4, tdps);
+				//decompressDataSeries_double_3D_pwr(&decmpData, r1*r2, r3, r4, tdps);
+				decompressDataSeries_double_3D_pwr_pre_log(&decmpData, r1*r2, r3, r4, tdps);
 				//ToDo
 				//decompressDataSeries_double_4D_pwr(&decmpData, r1, r2, r3, r4, tdps);
